﻿using UnityEngine;
using System.Collections;

public class AltControls : Controls {

	int currentColor = 0;

	// Update is called once per frame
	void Update () {
		bool bBoolsChanged = false;
		if(Input.GetKeyDown(KeyCode.Alpha1)){
			this.redActive = !this.redActive;
			bBoolsChanged = true;
		}
		if(Input.GetKeyDown(KeyCode.Alpha2)){
			this.greenActive = !this.greenActive;
			bBoolsChanged = true;
		}
		if(Input.GetKeyDown(KeyCode.Alpha3)){
			this.blueActive = !this.blueActive;
			bBoolsChanged = true;
		}
		if(bBoolsChanged){
			this.DefineCurrentColorFromRGB();
		}

		if(Input.GetAxis("Mouse ScrollWheel") < 0){
			this.currentColor--;
			if(this.currentColor < 0){
				this.currentColor += 8;
			}
			this.DefineRGBFromCurrentColor();
		}else if(Input.GetAxis("Mouse ScrollWheel") > 0){
			this.currentColor = (this.currentColor + 1) & 7;
			this.DefineRGBFromCurrentColor();
		}

		this.lightGunRedLight.renderer.material.color = this.redActive ? (Color)Utils.lightColorsColors[LightColor.Red] : (Color)Utils.lightColorsColors[LightColor.Black];
		this.lightGunGreenLight.renderer.material.color = this.greenActive ? (Color)Utils.lightColorsColors[LightColor.Green] : (Color)Utils.lightColorsColors[LightColor.Black];
		this.lightGunBlueLight.renderer.material.color = this.blueActive ? (Color)Utils.lightColorsColors[LightColor.Blue] : (Color)Utils.lightColorsColors[LightColor.Black];
		
		if(Input.GetMouseButtonDown(0)){
			this.FireLight();
		}
	}

	protected void DefineCurrentColorFromRGB(){
		this.currentColor = (this.redActive ? 1 : 0) + (this.greenActive ? 2 : 0) + (this.blueActive ? 4 : 0);
	}

	protected void DefineRGBFromCurrentColor(){
		this.redActive = (this.currentColor & 1) == 1;
		this.greenActive = ((this.currentColor >> 1) & 1) == 1;
		this.blueActive = ((this.currentColor >> 2) & 1) == 1;
	}

}
