﻿using UnityEngine;
using System.Collections;

public class BlackLightSpirit : MonoBehaviour {

	LightSpirit lightSpirit;

	protected float shiftTime;
	protected float visible;
	protected bool shiftWay;

	protected Color basecolor;

	// Use this for initialization
	void Start () {
		this.lightSpirit = this.gameObject.GetComponent<LightSpirit>();
		this.lightSpirit.Init(LightColor.Black);
		this.transform.Rotate(new Vector3(0, Random.value * 360, 0));
		this.visible = 0;
		this.shiftWay = false;
		this.basecolor = (Color)Utils.lightColorsColors[LightColor.Black];
		this.resetShiftTime();

		this.transform.Rotate(new Vector3(0, Random.value * 360, 0));
		this.transform.position = new Vector3(Random.value * 18 - 9, Random.value * 5 + 2, Random.value * 18 - 9);
	}
	
	// Update is called once per frame
	void Update () {
		this.shiftTime -= Time.deltaTime;

		// Decrease timer
		if(this.shiftTime <= 0){
			this.shiftWay = !this.shiftWay;
			this.resetShiftTime();
		}

		// Disappearing
		if(this.shiftWay == false && this.visible > 0){
			this.visible = Mathf.Max(0, this.visible - Time.deltaTime);
		}
		// Appearing
		if(this.shiftWay == true && this.visible < 1){
			this.visible = Mathf.Min(1, this.visible + Time.deltaTime);
		}

		if(this.visible < 1){
			this.collider.enabled = false;
			this.renderer.material.color = new Color(this.basecolor.r, this.basecolor.g, this.basecolor.b, this.visible);
		}else{
			this.collider.enabled = true;
			this.renderer.material.color = this.basecolor;
		}
	}

	protected void resetShiftTime(){
		this.shiftTime = Random.value * 2 + 2;
	}
}
