﻿using UnityEngine;
using System.Collections;


public class Controls : MonoBehaviour {

	public GameObject lightBall;

	protected bool redActive = false;
	protected bool blueActive = false;
	protected bool greenActive = false;

	protected Hashtable lightColorTable;

	protected GameObject lightGunRedLight;
	protected GameObject lightGunGreenLight;
	protected GameObject lightGunBlueLight;

	protected GameObject lightGun;


	// Use this for initialization
	void Start () {
		this.lightColorTable = new Hashtable();
		this.lightColorTable[0] = LightColor.Black;
		this.lightColorTable[1] = LightColor.Red;
		this.lightColorTable[2] = LightColor.Green;
		this.lightColorTable[3] = LightColor.Yellow;
		this.lightColorTable[4] = LightColor.Blue;
		this.lightColorTable[5] = LightColor.Majenta;
		this.lightColorTable[6] = LightColor.Cyan;
		this.lightColorTable[7] = LightColor.White;

		this.lightGunRedLight = this.transform.GetChild(0).FindChild("RedLight").gameObject;
		this.lightGunGreenLight = this.transform.GetChild(0).FindChild("GreenLight").gameObject;
		this.lightGunBlueLight = this.transform.GetChild(0).FindChild("BlueLight").gameObject;

		this.lightGun = this.transform.GetChild(0).gameObject;
	}
	
	// Update is called once per frame
	void Update () {
		this.redActive = Input.GetMouseButton(0);
		this.blueActive = Input.GetMouseButton(1);
		this.greenActive = Input.GetMouseButton(2) || Input.GetKey(KeyCode.LeftShift);

		this.lightGunRedLight.renderer.material.color = this.redActive ? (Color)Utils.lightColorsColors[LightColor.Red] : (Color)Utils.lightColorsColors[LightColor.Black];
		this.lightGunGreenLight.renderer.material.color = this.greenActive ? (Color)Utils.lightColorsColors[LightColor.Green] : (Color)Utils.lightColorsColors[LightColor.Black];
		this.lightGunBlueLight.renderer.material.color = this.blueActive ? (Color)Utils.lightColorsColors[LightColor.Blue] : (Color)Utils.lightColorsColors[LightColor.Black];

		if(Input.GetKeyDown(KeyCode.Space)){
			this.FireLight();
		}

	}

	protected void FireLight(){
		Vector3 vDirection = this.transform.TransformDirection(Vector3.forward);

		GameObject oLightBall = (GameObject)GameObject.Instantiate(this.lightBall);
		oLightBall.transform.position = this.transform.position + this.transform.TransformDirection(new Vector3(0, -0.35f, 0.8f));

		oLightBall.GetComponent<LightBall>().Init(this.ComputeColor(), vDirection);
		this.lightGun.GetComponent<AudioSource>().Play();
	}

	protected LightColor ComputeColor(){
		return (LightColor)this.lightColorTable[(this.redActive ? 1 : 0) + (this.greenActive ? 2 : 0) + (this.blueActive ? 4 : 0)];
	}

}
