﻿using UnityEngine;
using System.Collections;

public class CyanLightSpirit : MonoBehaviour {

	LightSpirit lightSpirit;

	protected float speed;
	protected bool way;
	protected float waitTime;
	protected float height;

	// Use this for initialization
	void Start () {
		this.lightSpirit = this.gameObject.GetComponent<LightSpirit>();
		this.lightSpirit.Init(LightColor.Cyan);

		this.transform.Rotate(new Vector3(0, Random.value * 360, 0));
		this.transform.position = new Vector3(Random.value * 18 - 9, -2, Random.value * 18 - 9);

		this.height = Random.value * 5 + 2;
		this.way = true;
		this.speed = 12.0f;
	}
	
	// Update is called once per frame
	void Update () {
		if(this.way){
			Vector3 vPosition = this.transform.position;
			vPosition.y += this.speed * Time.deltaTime;
			
			if(vPosition.y >= this.height){
				this.way = false;
				this.height = Random.value * 5 + 2;
				this.waitTime = Random.value * 2 + 1;
			}

			this.transform.position = vPosition;
		}else if(this.waitTime > 0){
			this.waitTime -= Time.deltaTime;
		}else{
			Vector3 vPosition = this.transform.position;
			vPosition.y -= this.speed * Time.deltaTime;
			
			if(vPosition.y <= -2){
				this.way = true;
				vPosition = new Vector3(Random.value * 18 - 9, -2, Random.value * 18 - 9);
			}
			
			this.transform.position = vPosition;
		}
	}
}
