﻿using UnityEngine;
using System.Collections;

public class GreenLightSpirit : MonoBehaviour {

	LightSpirit lightSpirit;

	Vector3 movement;
	float speed;
	float baseY;

	// Use this for initialization
	void Start () {
		this.lightSpirit = this.gameObject.GetComponent<LightSpirit>();
		this.lightSpirit.Init(LightColor.Green);
		this.speed = 5;
		this.movement = new Vector3(Random.value, 0, Random.value).normalized;

		// Position
		int iSide = Mathf.FloorToInt(Random.value * 4);
		this.baseY = Random.value * 5 + 2;
		switch(iSide){
		case 0:
			this.transform.position = new Vector3(12, this.baseY, Random.value * 24 - 12);
			break;
		case 1:
			this.transform.position = new Vector3(-12, this.baseY, Random.value * 24 - 12);
			break;
		case 2:
			this.transform.position = new Vector3(Random.value * 24 - 12, this.baseY, 12);
			break;
		case 3:
		default:
			this.transform.position = new Vector3(Random.value * 24 - 12, this.baseY, -12);
			break;
		}
	}
	
	// Update is called once per frame
	void Update () {
		Vector3 vPosition = this.transform.position + this.movement * Time.deltaTime * this.speed;

		if(vPosition.x < -12){
			vPosition.x = 12;
		}
		if(vPosition.x > 12){
			vPosition.x = -12;
		}
		if(vPosition.z < -12){
			vPosition.z = 12;
		}
		if(vPosition.z > 12){
			vPosition.z = -12;
		}

		vPosition.y = this.baseY + Mathf.Sin(Time.time * 8) * 2;

		this.transform.position = vPosition;
	}
}
