﻿using UnityEngine;
using System.Collections;

public class Gui : MonoBehaviour {
	public Texture crossHair;
	protected GameManager gameManager;
	public GUISkin skin;

	// Use this for initialization
	void Start () {
		this.gameManager = GameObject.Find("GameManager").GetComponent<GameManager>();
	}
	
	// Update is called once per frame
	void Update () {
		
	}

	void OnGUI(){
		GUI.skin = this.skin;

		if(this.gameManager.GetGameOver()){
			GUI.Label(new Rect(Screen.width / 2 - 300, Screen.height / 2 - 20, 600, 40), "GAME OVER", skin.label);
			GUI.Label(new Rect(Screen.width / 2 - 300, Screen.height / 2 + 20, 600, 40), "Your score is : " + this.gameManager.GetPlayerScore(), skin.label);

			if(GUI.Button(new Rect(Screen.width / 2 - 120, Screen.height / 2 + 60, 240, 40), "Back to main menu", skin.button)){
				Application.LoadLevel("menu");
			}
		}else{
			// Crosshair
			GUI.DrawTexture(new Rect(Screen.width / 2 - 32, Screen.height / 2 - 32, 64, 64), this.crossHair);

			// Score
			GUI.Label(new Rect(20, 40, 240, 40), "Score : " + this.gameManager.GetPlayerScore(), skin.label);

			// Timer
			int iSeconds = Mathf.CeilToInt(this.gameManager.GetGameTimer());
			GUI.Label(new Rect(Screen.width / 2 - 120, 40, 240, 40), iSeconds.ToString(), skin.label);
		}
	}
}
