﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class LightBall : MonoBehaviour {

	protected LightColor lightColor;
	protected Vector3 direction;
	protected float speed = 28;
	protected Vector3 rotation;
	protected float rotationSpeed = 5;

	// Use this for initialization
	void Start () {
		this.rotation = new Vector3(Random.value * 360, Random.value * 360, Random.value * 360);
	}
	
	public LightColor GetLightColor(){
		return this.lightColor;
	}


	public void Init(LightColor eLightColor, Vector3 vDirection){
		this.lightColor = eLightColor;
		this.renderer.material.color = (Color)Utils.lightColorsColors[this.lightColor];
		foreach(Renderer oRenderer in this.transform.GetComponentsInChildren<Renderer>()){
			oRenderer.material.color = (Color)Utils.lightColorsColors[this.lightColor];
		}
		this.GetComponentInChildren<Light>().color = (Color)Utils.lightColorsColors[this.lightColor];
		this.direction = vDirection;
	}

	// Update is called once per frame
	void Update () {
		this.transform.position += this.direction * this.speed * Time.deltaTime;
		this.transform.Rotate(this.rotation * this.rotationSpeed * Time.deltaTime);
	}

	void OnCollisionEnter(Collision oCollision) {
		foreach(ContactPoint oContactPoint in oCollision.contacts){
			Utils.ComputeCollision(this, oContactPoint.otherCollider.gameObject);
		}
		// Add particles

		GameObject.Destroy(this.gameObject);
	}
}
