﻿using UnityEngine;
using System.Collections;

public class MajentaLightSpirit : MonoBehaviour {
	
	LightSpirit lightSpirit;
	
	protected float moveTime;
	protected bool moving;
	
	protected float speed;
	protected float rotationSpeed;

	protected Vector3 movement;

	// Use this for initialization
	void Start () {
		this.lightSpirit = this.gameObject.GetComponent<LightSpirit>();
		this.lightSpirit.Init(LightColor.Majenta);

		this.transform.Rotate(new Vector3(0, Random.value * 360, 0));
		this.transform.position = new Vector3(Random.value * 18 - 9, Random.value * 5 + 2, Random.value * 18 - 9);

		this.speed = 8.0f;
		this.rotationSpeed = 500.0f;

		this.moving = false;
		this.resetShiftTime();
	}
	
	// Update is called once per frame
	void Update () {
		this.moveTime -= Time.deltaTime;
		
		// Decrease timer
		if(this.moveTime <= 0){
			this.moving = !this.moving;
			if(moving){
				this.movement = this.transform.TransformDirection(Vector3.forward);
			}
			this.resetShiftTime();
		}

		if(this.moving){
			this.transform.Rotate(Vector3.up, this.rotationSpeed * Time.deltaTime);
		}else{
			Vector3 vPosition = this.transform.position + this.movement * this.speed * Time.deltaTime;
			if(vPosition.x < -12){
				vPosition.x = 12;
			}
			if(vPosition.x > 12){
				vPosition.x = -12;
			}
			if(vPosition.z < -12){
				vPosition.z = 12;
			}
			if(vPosition.z > 12){
				vPosition.z = -12;
			}
			this.transform.position = vPosition;
		}
	}
	
	protected void resetShiftTime(){
		this.moveTime = Random.value * 2 + 2;
	}
}
