﻿using UnityEngine;
using System.Collections;

public class MenuGui : MonoBehaviour {

	protected int pageNum = 0;
	protected int pageMax = 2;
	public GUISkin skin;
	public Texture parchment;
	protected bool helpOpened;
	public Texture blackScreen;

	// Use this for initialization
	void Start () {

	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnGUI(){
		GUI.skin = this.skin;

		if(!helpOpened){
			GUI.Label(new Rect(Screen.width / 2 - 240, 82, 480, 80), "Light Spirits", skin.FindStyle("title"));
			GUI.Label(new Rect(Screen.width / 2 - 240, 80, 480, 80), "Light Spirits", skin.FindStyle("titleSub"));

			if(GUI.Button(new Rect(Screen.width / 2 - 120, Screen.height / 2 - 60, 240, 40), "New game", skin.button)){
				Application.LoadLevel("game");
			}
			if(GUI.Button(new Rect(Screen.width / 2 - 120, Screen.height / 2, 240, 40), "How to play", skin.button)){
				this.helpOpened = true;
			}
			if(GUI.Button(new Rect(Screen.width / 2 - 120, Screen.height / 2 + 60, 240, 40), "Quit game", skin.button)){
				Application.Quit();
			}
			GUI.Label(new Rect(Screen.width / 2 - 300, Screen.height - 160, 600, 160), "©2015 EvilTroopa\nFor Ludum Dare #32 - Compo\n\"Un unconventional weapon\"", this.skin.label);
		}else{
			GUI.DrawTexture(new Rect(0, 0, Screen.width, Screen.height), this.blackScreen);

			switch(pageNum){
			case 0:
				// Title
				GUI.Label(new Rect(Screen.width / 2 - 300, 40, 600, 80), "Story", this.skin.FindStyle("titleSub"));
				// Text
				GUI.Label(new Rect(20, 150, Screen.width / 2 - 40, 80), "The light spirits make one with the power of the light and then ascend once they reach absolute unity with all light waves.", this.skin.FindStyle("paragraph"));
				GUI.Label(new Rect(20, 300, Screen.width / 2 - 40, 80), "Some of them get stuck with only a few light waves absorbed and need help to feel complete. Some just need an extra push to implode into ascension.", this.skin.FindStyle("paragraph"));
				GUI.Label(new Rect(Screen.width / 2 + 20, 150, Screen.width / 2 - 40, 80), "This is when you get to use the Light Gun. Fire some light power with the correct color complement on the light spirits to help them take a step into a new form of existence.", this.skin.FindStyle("paragraph"));
				break;
			case 1:
				// Title
				GUI.Label(new Rect(Screen.width / 2 - 300, 40, 600, 80), "How to use the Light Gun", this.skin.FindStyle("titleSub"));
				// Text
				GUI.Label(new Rect(20, 150, Screen.width / 2 - 40, 80), "The light gun is a fine piece of hardware that can generate a ball of energy infused with light.\nWith the keys 1, 2 and 3, you can set which primary light colors to be used. You can also navigate through the different combinaisons with the mouse wheel.", this.skin.FindStyle("paragraph"));
				GUI.Label(new Rect(Screen.width / 2 + 20, 150, Screen.width / 2 - 40, 80), "To help the light sprits ascend, you need to complete their color using the right combinaison.\nOn the page is a copy of an old parchment explaining how complementarity works in light waves.", this.skin.FindStyle("paragraph"));
				break;
			case 2:
				// Title
				GUI.Label(new Rect(Screen.width / 2 - 300, 40, 600, 80), "Complementarity of light colors", this.skin.FindStyle("titleSub"));
				// Text
				GUI.DrawTexture(new Rect(Screen.width / 2 - 256, 120, 512, 512), this.parchment);
				break;		
			}
			
			if(GUI.Button(new Rect(20, Screen.height - 80, 240, 40), "Back to main menu", this.skin.button)){
				this.helpOpened = false;
			}
			
			if(this.pageNum > 0){
				if(GUI.Button(new Rect(Screen.width - 260 * 2, Screen.height - 80, 240, 40), "Previous", this.skin.button)){
					this.pageNum--;
				}
			}
			if(this.pageNum < this.pageMax){
				if(GUI.Button(new Rect(Screen.width - 260, Screen.height - 80, 240, 40), "Next", this.skin.button)){
					this.pageNum++;
				}
			}
		}
	}
}
