﻿using UnityEngine;
using System.Collections;

public class RedLightSpirit : MonoBehaviour {

	LightSpirit lightSpirit;

	protected float angle;
	protected float distance;
	protected bool clockWise;
	protected float speed;

	// Use this for initialization
	void Start () {
		this.lightSpirit = this.gameObject.GetComponent<LightSpirit>();
		this.lightSpirit.Init(LightColor.Red);

		this.angle = 45;//Random.value * 360;
		this.distance = Random.value * 5 + 3;
		this.clockWise = (Mathf.RoundToInt(Random.value) == 1);
		this.speed = 2;

		this.transform.position = new Vector3(Mathf.Cos(this.angle) * this.distance, Random.value * 5 + 2, -Mathf.Sin(this.angle) * this.distance);
		this.transform.Rotate(0, (this.clockWise ? 180 : 0) - this.angle, 0);
	}
	
	// Update is called once per frame
	void Update () {
		this.angle += speed * (this.clockWise ? 1.0f : -1.0f) * Time.deltaTime;
		this.transform.position = new Vector3(Mathf.Cos(this.angle) * this.distance, this.transform.position.y, -Mathf.Sin(this.angle) * this.distance);
		this.transform.Rotate(0, this.speed * (this.clockWise ? 1.0f : -1.0f) * Time.deltaTime, 0);
	}
}
