﻿using UnityEngine;
using System.Collections;

public enum LightColor{
	Black,
	Red,
	Green,
	Yellow,
	Blue,
	Majenta,
	Cyan,
	White
}

public class Utils {
	public static Hashtable lightColorsColors;

	public static Hashtable colorsComplements;

	protected static GameManager gameManager;

	public static void Init(GameManager oGameManager){
		Utils.lightColorsColors = new Hashtable();
		Utils.lightColorsColors.Add(LightColor.Black, new Color(0, 0, 0));
		Utils.lightColorsColors.Add(LightColor.Red, new Color(1, 0, 0));
		Utils.lightColorsColors.Add(LightColor.Green, new Color(0, 1, 0));
		Utils.lightColorsColors.Add(LightColor.Yellow, new Color(1, 1, 0));
		Utils.lightColorsColors.Add(LightColor.Blue, new Color(0, 0, 1));
		Utils.lightColorsColors.Add(LightColor.Majenta, new Color(1, 0, 1));
		Utils.lightColorsColors.Add(LightColor.Cyan, new Color(0, 1, 1));
		Utils.lightColorsColors.Add(LightColor.White, new Color(1, 1, 1));

		Utils.colorsComplements = new Hashtable();
		Utils.colorsComplements.Add(LightColor.Black, LightColor.White);
		Utils.colorsComplements.Add(LightColor.Red, LightColor.Cyan);
		Utils.colorsComplements.Add(LightColor.Green, LightColor.Majenta);
		Utils.colorsComplements.Add(LightColor.Yellow, LightColor.Blue);
		Utils.colorsComplements.Add(LightColor.Blue, LightColor.Yellow);
		Utils.colorsComplements.Add(LightColor.Majenta, LightColor.Green);
		Utils.colorsComplements.Add(LightColor.Cyan, LightColor.Red);
		Utils.colorsComplements.Add(LightColor.White, LightColor.Black);

		Utils.gameManager = oGameManager;
	}

	public static void ComputeCollision(LightBall oLightBall, GameObject oGameObject){
		LightSpirit oLightSpirit = oGameObject.GetComponent<LightSpirit>();
		if(oLightSpirit != null){
			if(oLightBall.GetLightColor() == (LightColor)Utils.colorsComplements[oLightSpirit.GetLightColor()]){
				Utils.gameManager.GoodHitSpirit(oLightSpirit);
			}else{
				Utils.gameManager.BadHitSpirit(oLightBall);
			}
		}
	}

}
